import progressBarComponent from './ProgressBar'

export default {
  
  progressBarInstance: null,

  install(Vue, options) {

    const progressBarConstructor = Vue.extend(progressBarComponent)
    this.progressBarInstance = new progressBarConstructor().$mount()
    document.body.appendChild(this.progressBarInstance.$el)

    const methods = Vue.$progress = Vue.prototype.$progress = {}
    methods.start = () => {
      this.progressBarInstance.$emit('start')
    }
    methods.finish = () => {
      this.progressBarInstance.$emit('finish')
    }
    methods.error = () => {
      this.progressBarInstance.$emit('errorFinish')
    }
    methods.warning = () => {
      this.progressBarInstance.$emit('warningFinish')
    }
    methods.success = () => {
      this.progressBarInstance.$emit('successFinish')
    }
  }
}